#include<bits/stdc++.h>
using namespace std;
const int N=5e5+5;
#define int long long
int n,q,f[N][31],dep[N];
int dp[N][32];
vector<int> g[N];
void dfs(int x,int fa) {
	f[x][0]=fa;
	dep[x]=dep[fa]+1;
	for(int i=1;i<=30;i++) f[x][i]=f[f[x][i-1]][i-1];
	for(auto v:g[x]) {
		if(v==fa) continue;
		dfs(v,x);
	}
}
int lca(int x,int y) {
	if(dep[x]<dep[y]) swap(x,y);
	for(int i=30;i>=0;i--) {
		if(dep[x]-(1<<i)>=dep[y]) x=f[x][i];
	}
	if(x==y) return x;
	for(int i=30;i>=0;i--) {
		if(f[x][i]!=f[y][i]) {
			x=f[x][i];
			y=f[y][i];
		}
	}
	return f[x][0];
}
void init() {
	for(int i=1;i<=n;i++) dp[i][0]=i;
	for(int i=1;i<=30;i++) {
		for(int j=1;j+(1<<i)-1<=n;j++) {
			dp[j][i]=lca(dp[j][i-1],dp[j+(1<<i-1)][i-1]);
		}
	}
}
signed main() {
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	cin>>n;
	for(int i=1;i<n;i++) {
		int u,v;
		cin>>u>>v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(1,0);
	init();
	cin>>q;
	while(q--) {
		int l,r,k;
		cin>>l>>r>>k;
		int az=log2(k),ans=0;
		for(int i=l;i+k-1<=r;i++) {
			int man=lca(dp[i][az],dp[i+k-1-(1<<az)+1][az]);
			ans=max(ans,dep[man]);
		}
		cout<<ans<<endl;
	}
	return 0;
}
/*
6
5 6
6 1
6 2
2 3
2 4
3
2 5 2
1 4 1
1 6 3
*/
